from sage.all import *

trials = 100

for i in range(trials):
    l = randint(1, 256)
    m = randint(1, 256)
    n = randint(1, 256)
    k = randint(2, 10)

    A = random_matrix(GF(2**k,'a'), l, m)
    B = random_matrix(GF(2**k,'a'), m, n)

    C0 = A*B
    C1 = A._multiply_classical(B)

    print " mul: %4d: gf(2^%2d) %3d, %3d, %3d"%(i,k,l,m,n)
    if( C0 != C1 ):
        print C0 - C1
    


for i in range(trials):
    m = randint(1, 256)
    n = randint(1, 256)
    k = randint(2, 10)

    A = random_matrix(GF(2**k,'a'),m, n)

    E0 = copy(A).echelon_form("naive",reduced=True)
    E1 = copy(A).echelon_form("table",reduced=True)
    E2 = copy(A).echelon_form("builtin",reduced=True)

    print "elim: %4d: gf(2^%2d) %3d x %3d"%(i,k,m,n)
    assert( E1 == E0 == E2 )

